<?php
require_once("xar_tags.php");
require_once("xar_path.php");
require_once("write.php");
require_once("hexstr.php");

xar_xml2xar( $argv[$argc-2], $argv[$argc-1] );

function writeString( &$fd, $data) {
	$string = "";
	for( $i=0; $i<strlen($data); $i++ ) {
		$string .= $data[$i]."\0";
	}
	fwrite( $fd, $string."\0\0");
}

function xar_xml2xar( $filename, $out) {
	global $output, $fd, $total;
	echo "Converting XML to XAR...\n";
	$total = 0;

	$fd = fopen($out, "wb");
	
	// Nast XML soubor
	$xml = DOMDocument::load($filename);
	$root = $xml->getElementsByTagName("xar")->item(0)->childNodes;
	
	// Header
	write32bitUint( $fd, 0x41524158, false);
	write32bitUint( $fd, 0x0a0dA3A3, false);
	
	xar_xml2xar_children($root);

	@fclose($fd);
}

function xar_xml2xar_children(&$root) {
	global $output, $fd, $total;
	static $proc = array('|', '/', '-', '\\');
	
	foreach($root as $item) {
			// Pro efekt :)
			echo "\rWritten tags: $total ".$proc[ $total%4 ];
			$total++;
			
		    if( $item->nodeType != 3 ) {
		    	// Kompresi nahradit nesmyslem
				if( $item->nodeName == "endcompression" || $item->nodeName == "startcompression" ) {
					write32bitUint( $fd, constant("TAG_DUMMY"), false);
					write32bitUint( $fd, 0, false);
				}
				else { // U ostatnch tag zapsat klasicky TAG, velikost zapem potom
					if( substr( $item->nodeName, 0, 4) == "TAG_" ) write32bitUint( $fd, substr( $item->nodeName, 4), false);
					else write32bitUint( $fd, constant("TAG_".strtoupper($item->nodeName)), false);

					$data = $item->getAttribute("data");
					if( strlen($data) != 0 ) {
						write32bitUint( $fd, strlen($data)/2, false);
						fwrite($fd, hexstr( $data ) );
					}
					elseif( $item->nodeName == "fileheader" ) {
						$version = "0.1";
						$producer = "xml2xar";
						$build = "0";
						
						$size = 3 + 4*3 + strlen($version)+1 + strlen($producer)+1 + strlen($build)+1;
						write32bitUint( $fd, $size, false);
						fwrite( $fd, "CXN");
						write32bitUint( $fd, $item->getAttribute("FileSize"), false);
						write32bitUint( $fd, $item->getAttribute("WebLink"), false);
						write32bitUint( $fd, $item->getAttribute("Refinement"), false);
						fwrite( $fd, $producer); fwrite( $fd, chr(0) );
						fwrite( $fd, $version);  fwrite( $fd, chr(0) );
						fwrite( $fd, $build);    fwrite( $fd, chr(0) );
					}
					elseif( $item->nodeName == "layerdetails" ) {
						$size = strlen( $item->getAttribute("name") )*2+2  +1;
						write32bitUint( $fd, $size, false);
	
						writeByte( $fd, $item->getAttribute("flags"));
						writeString( $fd, $item->getAttribute("name"));
					}
					elseif( $item->nodeName == "path_relative_filled_stroked" ||
					        $item->nodeName == "path_relative_stroked" ||
							$item->nodeName == "path_relative_filled") {
						
						$path = new xar_path( $item->getAttribute("d") );
						$path->relative();
						$data = $path->getBinaryString();
						write32bitUint( $fd, strlen($data), false);
						fwrite( $fd, $data);
					}
					else {
						write32bitUint( $fd, 0, false);
					}
					
					if( is_object($item->childNodes->item(0)) ) {
						write32bitUint( $fd, constant("TAG_DOWN"), false);
						write32bitUint( $fd, 0, false);
						xar_xml2xar_children( $item->childNodes );
						write32bitUint( $fd, constant("TAG_UP"), false);
						write32bitUint( $fd, 0, false);
					}
				}
			}
		}
}
?>
