<?php
require_once( dirname(__FILE__)."/xar_tags.php");
require_once( dirname(__FILE__)."/xar_path.php");

xml_draw( $argv[$argc-2], $argv[$argc-1] );

function xml_draw( $filename, $out ) {
	$pathlist = array();
	$num = 0;
	$mspf = 5;

	// Load XML file
	printf("%-45s", "Loading \"$filename\"...");
	$xml = DOMDocument::load($filename);
	echo " [done]\n";

	// Create output XML document
	$xmlo = new DOMDocument();
	$xar = $xmlo->createElement('xar');
	$chapter = $xmlo->createElement('chapter');
	$spread = $xmlo->createElement('spread');
	$document = $xmlo->createElement('document');
	$endoffile = $xmlo->createElement('endoffile');
	$fileheader = $xmlo->createElement('fileheader');
	$fileheader->setAttribute("FileType","CXN");
	$fileheader->setAttribute("FileSize","0");
	$fileheader->setAttribute("WebLink","0");
	$fileheader->setAttribute("Refinement","0");
	$fileheader->setAttribute("Producer","xml_draw");
	$fileheader->setAttribute("Version","0.1");
	$fileheader->setAttribute("Build","0");
	$chapter->appendChild( $spread );
	$document->appendChild($chapter);
	$xar->appendChild( $fileheader );
	$xar->appendChild( $document );
	$xar->appendChild( $endoffile );
	$xmlo->appendChild( $xar );
	$root = $spread;

	// Get all path records
	$frames_list = $xml->getElementsByTagName("path_relative_stroked");
	foreach($frames_list as $frame) $frames[] = $frame;
	
	// Create animation
	for( $n=0; $n<sizeof($frames); $n++ ) {
		$newframe = $xmlo->createElement('layer');
		
		$newdetails = $xmlo->createElement('layerdetails');
		$newdetails->setAttribute("size", 17);
		$newdetails->setAttribute("flags", 13);
		$number = ++$num;
		$s = sprintf("%04d", $number);
		$newdetails->setAttribute("name", "Frame $s");
		$newframe->appendChild($newdetails);

		$newdetails = $xmlo->createElement('layer_frameprops');
		$newdetails->setAttribute("size", 5);
		$newdetails->setAttribute("data", "0".$mspf."00000000");
		$newframe->appendChild($newdetails);

		$root->appendChild($newframe);


		foreach( $pathlist as $p ) {
			$p1 = $p->cloneNode(true);
			$newframe->appendChild( $p1 );
		}
		$path = $xmlo->createElement('path_relative_filled_stroked');
		$path->setAttribute("d", $frames[$n]->getAttribute("d") );
		$newframe->appendChild( $path );
		$pathlist[] = $path;
	}

	// Save document
	printf("%-45s", "Saving to \"$out\"...");
	$xmlo->save($out);
	echo " [done]\n";
}
?>
